Index: /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limdyn.F90
===================================================================
--- /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limdyn.F90	(revision 3937)
+++ /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limdyn.F90	(revision 3938)
@@ -28,4 +28,5 @@
    USE in_out_manager   ! I/O manager
    USE prtctl           ! Print control
+   USE lib_fortran      ! glob_sum
 
    IMPLICIT NONE
@@ -64,8 +65,20 @@
       REAL(wp), POINTER, DIMENSION(:)   ::   zmsk           ! i-averaged of tmask
       REAL(wp), POINTER, DIMENSION(:,:) ::   zu_io, zv_io   ! ice-ocean velocity
-      !!---------------------------------------------------------------------
+      REAL(wp) :: zchk_v_i, zchk_smv, zchk_fs, zchk_fw, zchk_v_i_b, zchk_smv_b, zchk_fs_b, zchk_fw_b ! Check conservation (C Rousset)
+     !!---------------------------------------------------------------------
 
       CALL wrk_alloc( jpi, jpj, zu_io, zv_io )
       CALL wrk_alloc( jpj, zind, zmsk )
+
+      ! -------------------------------
+      !- check conservation (C Rousset)
+      IF (ln_limdiahsb) THEN
+         zchk_v_i_b = glob_sum( SUM(   v_i(:,:,:), dim=3 ) * area(:,:) * tms(:,:) )
+         zchk_smv_b = glob_sum( SUM( smv_i(:,:,:), dim=3 ) * area(:,:) * tms(:,:) )
+         zchk_fw_b  = glob_sum( rdmicif(:,:) * area(:,:) * tms(:,:) )
+         zchk_fs_b  = glob_sum( ( fsbri(:,:) + fseqv(:,:) + fsalt_res(:,:) + fsalt_rpo(:,:) ) * area(:,:) * tms(:,:) )
+      ENDIF
+      !- check conservation (C Rousset)
+      ! -------------------------------
 
       IF( kt == nit000 )   CALL lim_dyn_init   ! Initialization (first time-step only)
@@ -207,4 +220,39 @@
       ENDIF
       !
+
+      ! -------------------------------
+      !- check conservation (C Rousset)
+      IF (ln_limdiahsb) THEN
+         !INTEGER                                 ::   numhsb 
+         !CHARACTER (len=32) ::   cl_name  ! output file name
+         !cl_name    = 'heat_salt_volume_budgets.txt'                         ! name of output file
+
+         zchk_fs  = glob_sum( ( fsbri(:,:) + fseqv(:,:) + fsalt_res(:,:) + fsalt_rpo(:,:) ) * area(:,:) * tms(:,:) ) - zchk_fs_b
+         zchk_fw  = glob_sum( rdmicif(:,:) * area(:,:) * tms(:,:) ) - zchk_fw_b
+ 
+         zchk_v_i = ( glob_sum( SUM(   v_i(:,:,:), dim=3 ) * area(:,:) * tms(:,:) ) - zchk_v_i_b - ( zchk_fw / rhoic ) ) / rdt_ice
+         zchk_smv = ( glob_sum( SUM( smv_i(:,:,:), dim=3 ) * area(:,:) * tms(:,:) ) - zchk_smv_b ) / rdt_ice + ( zchk_fs / rhoic )
+
+         IF(lwp) THEN
+            IF (    ABS( zchk_v_i   ) >  1.e-5 ) WRITE(numout,*) 'violation volume [m3/day]     (limdyn) = ',(zchk_v_i * 86400.)
+            IF (    ABS( zchk_smv   ) >  1.e-4  ) WRITE(numout,*) 'violation saline [psu*m3/day] (limdyn) = ',(zchk_smv * 86400.)
+            IF ( MINVAL( v_i(:,:,:) ) <  0.    ) WRITE(numout,*) 'violation v_i<0  [mm]         (limdyn) = ',(MINVAL(v_i) * 1.e-3)
+            IF ( MAXVAL( SUM(a_i(:,:,:),dim=3) ) > amax+1.e-10 ) WRITE(numout,*) 'violation a_i>amax    (limdyn) = ',MAXVAL(SUM(a_i,dim=3))
+         ENDIF
+         !CALL ctl_opn( numhsb , cl_name , 'UNKNOWN' , 'FORMATTED' , 'SEQUENTIAL' , 1 , numout , lwp , 1 )
+         !
+         !WRITE( numhsb, 9010 ) "kt   |     heat content budget     |            salt content budget             ",   &
+         !     &                                                  "|            volume budget (ssh)             ",   &
+         !     &                                                  "|            volume budget (e3t)             "
+         !WRITE( numhsb, 9010 ) "     |      [C]         [W/m2]     |     [psu]        [mmm/s]          [SV]     ",   &
+         !     &                                                  "|     [m3]         [mmm/s]          [SV]     ",   &
+         !     &                                                  "|     [m3]         [mmm/s]          [SV]     "
+         !IF ( kt == nitend ) CLOSE( numhsb )
+         
+!9010     FORMAT(A80,A45,A45)
+      ENDIF
+      !- check conservation (C Rousset)
+      ! -------------------------------
+
       CALL wrk_dealloc( jpi, jpj, zu_io, zv_io )
       CALL wrk_dealloc( jpj, zind, zmsk )
@@ -228,5 +276,5 @@
          &                dm, nbiter, nbitdr, om, resl, cw, angvg, pstar,   &
          &                c_rhg, etamn, creepl, ecc, ahi0, &
-         &                nevp, telast, alphaevp
+         &                nevp, telast, alphaevp, hminrhg
       !!-------------------------------------------------------------------
 
@@ -256,4 +304,5 @@
          WRITE(numout,*) '   timescale for elastic waves                      telast = ', telast
          WRITE(numout,*) '   coefficient for the solution of int. stresses  alphaevp = ', alphaevp
+         WRITE(numout,*) '   min ice thickness for rheology calculations     hminrhg = ', hminrhg
       ENDIF
       !
Index: /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limhdf.F90
===================================================================
--- /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limhdf.F90	(revision 3937)
+++ /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limhdf.F90	(revision 3938)
@@ -136,4 +136,24 @@
       END DO                                       ! end of sub-time step loop
 
+      ! -----------------------
+      !!! final step (clem) !!!
+      DO jj = 1, jpjm1                                ! diffusive fluxes in U- and V- direction
+         DO ji = 1 , fs_jpim1   ! vector opt.
+            zflu(ji,jj) = pahu(ji,jj) * e2u(ji,jj) / e1u(ji,jj) * ( ptab(ji+1,jj) - ptab(ji,jj) )
+            zflv(ji,jj) = pahv(ji,jj) * e1v(ji,jj) / e2v(ji,jj) * ( ptab(ji,jj+1) - ptab(ji,jj) )
+         END DO
+      END DO
+      !
+      DO jj= 2, jpjm1                                 ! diffusive trend : divergence of the fluxes
+         DO ji = fs_2 , fs_jpim1   ! vector opt. 
+            zdiv (ji,jj) = (  zflu(ji,jj) - zflu(ji-1,jj  )   &
+                 &            + zflv(ji,jj) - zflv(ji  ,jj-1)  ) / ( e1t (ji,jj) * e2t (ji,jj) )
+            ptab(ji,jj) = ztab0(ji,jj) + 0.5 * ( zdiv(ji,jj) + zdiv0(ji,jj) )
+         END DO
+      END DO
+      CALL lbc_lnk( ptab, 'T', 1. )                   ! lateral boundary condition
+      !!! final step (clem) !!!
+      ! -----------------------
+
       IF(ln_ctl)   THEN
          zrlx(:,:) = ptab(:,:) - ztab0(:,:)
